<< FeynArts`

<< FormCalc`

SetOptions[InsertFields,
  ExcludeParticles -> {V, S[4], S[6], S[1], S[2], S[3], S[5]},
  Model -> MSSMQCD]

SetOptions[CalcFeynAmp,
  Dimension -> 4]

SetOptions[PrepareExpr,
  Expensive -> _B0i,
  Optimize -> True,
  FinalTouch -> simp]

SetOptions[WriteExpr,
  IndexType -> "integer"]


$PaintSE = "."


Mcorr[t_, g1_, g2_] := 
Block[ {se},
  se = -SelfEnergy[F[t, {g1}] -> F[t, {g2}], 0];
  { LScalarCoeff[se],
    1/2 LVectorCoeff[se],
    1/2 RVectorCoeff[se] }
]

IDelta/: IDelta[i_, j_] a_ := IDelta[i, j] (a /. j -> i) /; !FreeQ[a, j]

Delta[i_, i_] = 1

simp[x_] := FullSimplify[x /. Delta -> IDelta /. IDelta -> Delta]


me = $Input

write[t_, tag_] :=
Block[ {expr, hh},
  expr = Mcorr[t, g1, g2] /. IndexDelta -> IDelta /. IDelta -> Delta;

  Put[expr, tag <> ".m"];

  hh = OpenFortran[tag <> ".F"];

  WriteString[hh, "\
* " <> tag <> ".F\n\
* mass-matrix corrections\n\
* generated by " <> me <> " " <> TimeStamp[] <> "\n\n\
#include \"defs.h\"\n\n\n\
\tsubroutine " <> tag <> "(se, g1, g2)\n\
\timplicit none\n\
\tdouble complex se(3)\n\
\tinteger g1, g2\n\n\
#include \"looptools.h\"\n\n"];

  WriteExpr[hh, Thread[Array[se, 3] -> expr]];

  WriteString[hh, "\tend\n"];

  Close[hh]
]


write[4, "MDcorr"];

